Redmine - Feature #6446

Remove length limits on project identifier and name
2010-09-20 19:04 - Felix Schafer

Status: Closed Start date: 2010-09-20
Priority: Low Due date:

Assignee: Felix Schafer % Done: 0%
Category: Projects Estimated time: 0.00 hour
Target version: 1.1.0

Resolution: Fixed

Description

Do the length limits make any sense (other than limiting website clutter and such), e.g. breaking PDF layout? If it doesn't make
sense, we could just get rid of them.

IRC Excerpt:
[18:49] edavislO: thegcat: we can bump it up if you want to do a review and see why it's so small.
PDF export size?

[18:50] edavislO: same for identifier

[18:53] edavislO: thegcat: I'd rather 255 unless there is a reason not to (PDF, etc)

Related issues:

Blocked by Redmine - Patch #1789: Raise project-name length-limit from 30 to ... Closed 2008-08-14
Blocked by Redmine - Feature #504: 12 character project id limitation is too ... Closed

Blocked by Redmine - Patch #1998: Raise project-identifier length-limit from ... Closed 2008-10-07
Blocked by Redmine - Feature #1893: The field size of project name and identi... Closed 2008-09-13
Precedes Redmine - Defect #2719: Increase username length limit from 30 to 60 Closed 2010-09-21

Associated revisions

Revision 4402 - 2010-11-14 13:33 - Jean-Philippe Lang

Raised maximum length of project names and identifiers to 255 and 100 respectively (#6446).

Revision 4403 - 2010-11-14 14:16 - Jean-Philippe Lang

Updates mantis importer for new project name/identifier max lengths (#6446).

History

#1 - 2010-09-23 08:58 - Jean-Baptiste Barth

It would be great to test it a bit, | don't think there's any major issue (maybe things hidden in PDF exports). I'm surprised to see this subject discussed
again and again. Let's take a decision and go on :)

#2-2010-10-29 23:44-G N

People have been asking you to raise this useless limit for several years. Please make a decision and resolve this issue by setting a value > 200
chars! This breaks almost every migration from other platforms and IMO there is no reason valid enough for keeping this restriction.

#3 -2010-10-30 00:18 - G N
George Notaras wrote:
This breaks almost every migration from other platforms

| don't mean that it breaks ticket imports etc. It breaks the most important part of a web site: the project URL. There have been several changes in the
URL scheme in the past. Please make the right decisions from the beginning about URLs. They are very important.

#4 - 2010-10-30 02:34 - G N
- File redmine-project-name-and-identifier-limits.diff added

- File redmine-project-name-and-identifier-limits__mantis.diff NOT_USED added
I've written a patch to raise the limit of projects names and identifiers to 100 characters. Please note that | am not a Ruby/RoR programmer.

Nevertheless, | use this patch on a production system, a web site for my personal open source projects and | am able to use long names in the

project names and project identifiers.

For those not familiar with patching, to apply the patch, change to the redmine root dir and run:

patch -p0 < /path/to/redmine-project-name-and-identifier-limits.diff

To reverse the patch:

patch -R -p0 < /path/to/redmine-project-name-and-identifier-limits.diff

#5-2010-10-30 16:37-G N

Forgot to mention that, after applying the patch, you also need to run:

rake db:migrate RAILS_ENV=production

... for the limit to be changed in the database.

#6 - 2010-11-02 19:26 - Pedro Kroger

- File long-names-collision.png added

| tried George Notaras' patch and it's working beautifully. The only downsize is that long titles will collide with the tabs:
long-names-collision.png

But | think it's really important to have longer names than 30 characters. | see two solutions; moving the search entry to another place (and having
only the title in that row) or showing the title's first n characters.

#7 - 2010-11-14 05:20 - Mischa The Evil

I've updated this issues relations making this a placeholder for the old issues floating around.

#8 - 2010-11-14 10:56 - Jean-Philippe Lang

Just because I'm curious, could someone give a real example of a 200 chars project identifier?

#9 - 2010-11-14 11:11 - Felix Schafer

| have a "Softwaretechnik - Praxis (Wintersemester 2010/2011)" (51 chars) here, but let's ask the question the other way round: any reason not to
bump it up to 255 chars/CHAR length? The DB server at least shouldn't care, rails shouldn't either ;-)

#10 - 2010-11-14 12:01 - Jean-Philippe Lang

Felix Schéfer wrote:
| have a "Softwaretechnik - Praxis (Wintersemester 2010/2011)" (51 chars) here

This is not exactly a project identifier and we are far from 255 chars.

Also, this example looks like a subproject thing (Softwaretechnik > Praxis > Wintersemester 2010/2011), doesn't it?
but let's ask the question the other way round: any reason not to bump it up to 255 chars/CHAR length? The DB server at least shouldn't care,
rails shouldn't either ;-)

Of course, it's not a technical problem. We could also change the project name to a long text, why not? :-)

My concern is the Ul (see the example above). The main thing is: where should we display these 255 chars long project names? I'm afraid that the
page header is not the right place for that.

#11 - 2010-11-14 12:20 - Felix Schafer
Jean-Philippe Lang wrote:
Felix Schéafer wrote:
| have a "Softwaretechnik - Praxis (Wintersemester 2010/2011)" (51 chars) here

This is not exactly a project identifier and we are far from 255 chars.
Also, this example looks like a subproject thing (Softwaretechnik > Praxis > Wintersemester 2010/2011), doesn't it?
Oh, sorry, title. The whole hierarchy would be something along Technische Universitét Berlin > Fakultat Elektrotechnik und Informatik > Institut far
Softwaretechnik und Theoretische Informatik > Softwaretechnik - Praxis (Wintersemester 2010/2011), the only thing that could be broken down in the
last stage would be Softwaretechnik - Praxis > Wintersemester 2010/2011 (and IIRC in the project hierarchy it is, | don't have it open), but breaking
the name up would mean having many projects just called "Wintersemester 2010/2011", not exactly easy to read...

but let's ask the question the other way round: any reason not to bump it up to 255 chars/CHAR length? The DB server at least shouldn't
care, rails shouldn't either ;-)

Of course, it's not a technical problem. We could also change the project name to a long text, why not? :-)

My concern is the Ul (see the example above). The main thing is: where should we display these 255 chars long project names? I'm afraid that
the page header is not the right place for that.

IMHO presentation should not be (such) a (big) consideration when making technical/backend decisions, but a few places that come to mind that
could accommodate longer project names: the "title"-header (at least when in a "project" view, could be truncated for other cases), the project list,
even the top Ul if the theme defines a smaller font, and so on.

#12 - 2010-11-14 13:40 - Jean-Philippe Lang

- Category set to Projects

- Status changed from New to Resolved

- Target version changed from Unplanned backlogs to 1.1.0

- Resolution set to Fixed
Fair enough. Limits for project names and identifiers were raised respectively to 255 and 100 in r4402.
The 100 chars limit was kept for identifiers considering usual filesystems limits, since this identifier may already be used to name things on the

filesystem (eg. automatic repository creation). If longer identifiers are really needed, Project::IDENTIFIER_MAX_LENGTH can be easily adjusted
since both fields were changed to varchar(255) in the database.

#13 -2010-11-14 23:46 -G N
Thanks for resolving this issue.

I noticed that projects with longer names than 30 characters do not appear in the drop down box on the top right corner. | made this observation while
using the patch | posted in a previous message.

I'd like to know if this is an issue for other users and, if it is an actual bug, whether r4402 fixes that too or not.

Thanks in advance
#14 - 2010-11-15 00:58 - Mischa The Evil
George Notaras wrote:

| noticed that projects with longer names than 30 characters do not appear in the drop down box on the top right corner. | made this observation
while using the patch | posted in a previous message.

I'd like to know if this is an issue for other users and, if it is an actual bug, whether r4402 fixes that too or not.

| have reviewed and tested r4402 and am not able to replicate your issue. Though | can't see anything in both your patch nor the applied changeset
which might affect the inclusion of projects in the menu in the top right corner. Are you sure that you are a member of the project? Otherwise the
projects don't show up in the drop down at all...

Please open a new issue, if needed, to keep this issue on-topic :wink:

Kind regards,

Mischa.

#15 - 2010-11-1515:58 -G N

Mischa The Evil wrote:

Are you sure that you are a member of the project? Otherwise the projects don't show up in the drop down at all...

... | had forgotten to make myself a member of those projects as | had created them only for testing... Sorry about that.

#16 - 2010-11-27 14:33 - Jean-Philippe Lang
- Status changed from Resolved to Closed

#17 - 2011-03-11 05:06 - whoiam whoiam

Could you please give me some guides how to raise project-name length-limit from 30 to 60 characters by writing a plugin instead of a patch file?

Thanks in advance

Files

redmine-project-name-and-identifier-limits.diff 3.19 KB 2010-10-30 GN
redmine-project-name-and-identifier-limits___mantis.diff. NOT_USED 664 Bytes 2010-10-30 GN
long-names-collision.png 25.2 KB 2010-11-02 Pedro Kroger
